/*
 * Хꥺɽե
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: br_window.c,v 1.1 2000/05/29 00:07:37 tonton Exp $
 */

#include <gtk/gtk.h>

#include "brthm.h"

static gboolean		Wbrw_init_flag;		// ե饰

static void			wbrw_cb_window_destroy(void);
static void			wbrw_cb_mview_date_today_clicked(GtkWidget *,
												gpointer, guint);
static void			wbrw_cb_disp_status_change(GtkWidget *,
												gpointer, guint);
static GtkWidget	*wbrw_create_main_menu(GtkWidget *);

/*===============
 *   ̾ : wbr_dialog_close_clicked()
 *     ǽ : õ
 *    : ʤ
 */
void				wbr_dialog_close_clicked(
GtkButton			*button,			// (I) ܥ
gpointer			dialog				// (I) 
)
{
	gtk_widget_destroy(dialog);
}

/*===============
 *   ̾ : wbr_create_main_window()
 *     ǽ : ɥ
 *    : ᥤ󥦥ɥ
 */
GtkWidget			*wbr_create_main_window(void)
{
	GtkWidget		*main_window;		// ᥤ󥦥ɥ
	GtkWidget		*main_vbox;			// ˥塼ܥå
	GtkWidget		*menu_bar;			// ˥塼С
	GtkWidget		*draw_area;			// 襨ꥢ
	gchar			*title;				// ȥʸ

	Wbrw_init_flag = FALSE;

	// ᥤ󥦥ɥ
	title = g_strconcat(WBR_TITLE, NULL);
	main_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(main_window), title);
	gtk_widget_set_usize(GTK_WIDGET(main_window),
						(gint)wbr_get_param(WBR_PRM_ID_GRAPHWIDTH),
						(gint)wbr_get_param(WBR_PRM_ID_GRAPHHEIGHT));

	gtk_signal_connect(GTK_OBJECT(main_window), "destroy",
						GTK_SIGNAL_FUNC(wbrw_cb_window_destroy),
						NULL);
	gtk_widget_realize(main_window);
	g_free(title);

	// ˥塼С
	main_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_border_width(GTK_CONTAINER(main_vbox), 1);
	gtk_container_add(GTK_CONTAINER(main_window), main_vbox);
	menu_bar = wbrw_create_main_menu(main_window);
	gtk_box_pack_start(GTK_BOX(main_vbox), menu_bar, FALSE, TRUE, 0);
	gtk_widget_show(main_vbox);
	gtk_widget_show(menu_bar);

	// 襨ꥢ
	draw_area = wbr_create_draw_area(main_vbox);
	gtk_widget_show(draw_area);

	Wbrw_init_flag = TRUE;
	return main_window;
}

/*===============
 *   ̾ : wbrw_cb_window_destroy()
 *     ǽ : λ
 *    : ʤ
 */
static void			wbrw_cb_window_destroy(void)
{
	wbr_write_inifile();
	gtk_main_quit();
}

/*===============
 *   ̾ : wbrw_cb_mview_date_today_clicked()
 *     ǽ : ɽѹ˥塼κܥ󲡲Хå
 *    : ʤ
 */
static void			wbrw_cb_mview_date_today_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			client_data,		// (I) ̤
guint				button_no			// (I) ̤
)
{
	time_t			now_date;			// 

	now_date = time(NULL);
	wbr_put_param(WBR_PRM_ID_DISPDAY, (void *)now_date);
	wbr_draw_brthm();
}

/*===============
 *   ̾ : wbrw_cb_disp_status_change()
 *     ǽ : ɽɽܥ󲡲Хå
 *    : ʤ
 */
static void			wbrw_cb_disp_status_change(
GtkWidget			*button,			// (I) ܥ
gpointer			client_data,		// (I) ̤
guint				button_no			// (I) ܥֹ
)
{
	gint			button_status;		// ܥ󲡲

	button_status = (gint)wbr_get_param(WBR_PRM_ID_GRAPHDISP);

	button_status ^= button_no;
	wbr_put_param(WBR_PRM_ID_GRAPHDISP, (void *)button_status);

	if (Wbrw_init_flag == TRUE) {
		wbr_draw_brthm();
	}
}

/*===============
 *   ̾ : wbrw_create_main_menu()
 *     ǽ : ˥塼
 *    : ˥塼
 */
static GtkWidget	*wbrw_create_main_menu(
GtkWidget			*parent				// (I) ƥɥ
)
{
	GtkItemFactoryEntry menu_items[] =
	{
		{"/ե(_F)", NULL, NULL, 0, "<Branch>"},
		{"/ե(F)/λ", "<control>Q", gtk_main_quit, 0, NULL},

		{"/ɽ(_V)", NULL, NULL, 0, "<Branch>"},
		{"/ɽ(V)/tearoff", NULL, NULL, 0, "<Tearoff>"},
		{"/ɽ(V)/ɽѹ(_H)...", "<control>H",
			wbr_cb_mview_spcbirth_clicked,
			GPOINTER_TO_UINT(parent), NULL},
		{"/ɽ(V)/ɽѹ(_D)", NULL, NULL, 0, "<Branch>"},
		{"/ɽ(V)/ɽѹ(D)/(_T)", "<control>T",
			wbrw_cb_mview_date_today_clicked,
			GPOINTER_TO_UINT(parent), NULL},
		{"/ɽ(V)/ɽѹ(D)/ջ(_R)...", "<control>R",
			wbr_cb_mview_date_specify_clicked,
			GPOINTER_TO_UINT(parent), NULL},
		{"/ɽ(V)/sep1", NULL, NULL, 0, "<Separator>"},
		{"/ɽ(V)/Υ(_P)", "<control>P",
			wbrw_cb_disp_status_change, 1, "<CheckItem>"},
		{"/ɽ(V)/𥰥(_S)", "<control>S",
			wbrw_cb_disp_status_change, 2, "<CheckItem>"},
		{"/ɽ(V)/(_I)", "<control>I",
			wbrw_cb_disp_status_change, 4, "<CheckItem>"},
		{"/ɽ(V)/(_W)", "<control>W",
			wbrw_cb_disp_status_change, 8, "<CheckItem>"},

		{"/إ(_H)", NULL, NULL, 0, "<LastBranch>"},
		{"/إ(H)/С(_A)...", NULL,
			wbr_cb_mhelp_about_clicked, GPOINTER_TO_UINT(parent), NULL},
	};
	gint			nmenu_items;		// ˥塼ܿ
	GtkItemFactory	*item_factory;
	GtkAccelGroup	*accel_group;
	GtkWidget		*check_item;		// åܥ
	gint			button_status;		// ܥ󲡲

	nmenu_items = sizeof(menu_items) / sizeof(menu_items[0]);
	accel_group = gtk_accel_group_new();
	item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR,
									"<main>", accel_group);
	gtk_item_factory_create_items_ac(item_factory,
					nmenu_items, menu_items, parent, 2);

	gtk_accel_group_attach(accel_group, GTK_OBJECT(parent));

	button_status = (gint)wbr_get_param(WBR_PRM_ID_GRAPHDISP);
	if ((button_status & WBR_TYPE_PHYS) != 0) {
		check_item = gtk_item_factory_get_item(item_factory,
									"/ɽ(V)/Υ(P)");
		gtk_check_menu_item_set_active((GtkCheckMenuItem *)check_item,
																TRUE);
		button_status |= WBR_TYPE_PHYS;
	}
	if ((button_status & WBR_TYPE_SENS) != 0) {
		check_item = gtk_item_factory_get_item(item_factory,
									"/ɽ(V)/𥰥(S)");
		gtk_check_menu_item_set_active((GtkCheckMenuItem *)check_item,
																TRUE);
		button_status |= WBR_TYPE_SENS;
	}
	if ((button_status & WBR_TYPE_INTEL) != 0) {
		check_item = gtk_item_factory_get_item(item_factory,
									"/ɽ(V)/(I)");
		gtk_check_menu_item_set_active((GtkCheckMenuItem *)check_item,
																TRUE);
		button_status |= WBR_TYPE_INTEL;
	}
	if ((button_status & WBR_TYPE_WARN) != 0) {
		check_item = gtk_item_factory_get_item(item_factory,
									"/ɽ(V)/(W)");
		gtk_check_menu_item_set_active((GtkCheckMenuItem *)check_item,
																TRUE);
		button_status |= WBR_TYPE_WARN;
	}
	wbr_put_param(WBR_PRM_ID_GRAPHDISP, (void *)button_status);

	return gtk_item_factory_get_widget(item_factory, "<main>");
}
