/*
 * Хꥺɽե
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: br_birth.c,v 1.1 2000/05/29 00:07:37 tonton Exp $
 */

#include <gtk/gtk.h>
#include <time.h>

#include "brthm.h"

static GtkWidget		*Wbrb_mwindow;	// ᥤ󥦥ɥ
static GtkWidget		*Wbrb_name;		// ̾
static GtkAdjustment	*Wbrb_year;		// ǯ
static GtkAdjustment	*Wbrb_month;	// 
static GtkAdjustment	*Wbrb_day;		// 
static gint			Wbrb_calendar;		// ܥֹ
static gfloat		Wbrb_cal_year[] = {	// Ѵ
						0, 1867, 1911, 1925, 1988
					};

static GtkWidget	*wbrb_create_birth_window(GtkWidget *);
static void			wbrb_cb_calendar_clicked(GtkWidget *,
										gpointer, guint);
static void			wbrb_cb_ok_clicked(GtkWidget *,
										gpointer, guint);
static void			wbrb_cb_cancel_clicked(GtkWidget *,
										gpointer, guint);

/*===============
 *   ̾ : wbr_cb_mview_spcbirth_clicked()
 *     ǽ : ϥɥκ
 *    : ʤ
 */
void				wbr_cb_mview_spcbirth_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			clinet_data,		// (I) ̤
guint				main_window			// (I) ᥤ󥦥ɥ
)
{
	GtkWidget		*birth_window;		// ϥɥ
	GtkWidget		*mwin_ptr;			// ᥤ󥦥ɥ

	Wbrb_calendar = (gint)wbr_get_param(WBR_PRM_ID_CALENDAR);
	mwin_ptr = GUINT_TO_POINTER(main_window);
	if (mwin_ptr == NULL) {
		Wbrb_mwindow = wbr_create_main_window();
	}
	birth_window = wbrb_create_birth_window(mwin_ptr);
	gtk_widget_show_all(birth_window);
}

/*===============
 *   ̾ : wbrb_cb_calendar_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_calendar_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			btn_no,				// (I) ܥֹ
guint				call_data			// (I) ̤
)
{
	gboolean		is_active;			// ܥ󲡲
	gfloat			now_year;			// ǯ

	is_active = GTK_TOGGLE_BUTTON(button)->active;

	if (is_active == TRUE) {
		now_year = GTK_ADJUSTMENT(Wbrb_year)->value
							+ Wbrb_cal_year[Wbrb_calendar];
		now_year -= Wbrb_cal_year[(gint)btn_no];
		Wbrb_calendar = (gint)btn_no;
		gtk_adjustment_set_value(GTK_ADJUSTMENT(Wbrb_year), now_year);
	}
}

/*===============
 *   ̾ : wbrb_cb_ok_clicked()
 *     ǽ : ɽܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_ok_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ϥɥ
guint				call_data			// (I) ̤
)
{
	gchar			*user_name;			// ̾
	time_t			ymd_time;			// ɽ
	struct tm		ymd_stime;			// ɽ

	user_name = gtk_entry_get_text(GTK_ENTRY(Wbrb_name));
	memset(&ymd_stime, 0, sizeof(struct tm));
	ymd_stime.tm_year = GTK_ADJUSTMENT(Wbrb_year)->value
						+ Wbrb_cal_year[Wbrb_calendar] - 1900;
	ymd_stime.tm_mon = GTK_ADJUSTMENT(Wbrb_month)->value - 1;
	ymd_stime.tm_mday = GTK_ADJUSTMENT(Wbrb_day)->value;

	ymd_time = mktime(&ymd_stime);
	wbr_init_user_info();
	wbr_put_user_info(user_name, ymd_time);
	wbr_put_param(WBR_PRM_ID_CALENDAR, (void *)Wbrb_calendar);

	gtk_widget_destroy(main_window);
	if (Wbrb_mwindow != NULL) {
		gtk_widget_show(Wbrb_mwindow);
		Wbrb_mwindow = NULL;
	}
	wbr_draw_brthm();
}

/*===============
 *   ̾ : wbrb_cb_cancel_clicked()
 *     ǽ : ߥܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_cancel_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ϥɥ
guint				call_data			// (I) ̤
)
{
	if (Wbrb_mwindow != NULL) {
		gtk_main_quit();
	}
	else {
		gtk_widget_destroy(main_window);
	}
}

/*===============
 *   ̾ : wbrb_create_birth_window()
 *     ǽ : ɥ
 *    : ɥ
 */
static GtkWidget	*wbrb_create_birth_window(
GtkWidget			*parent				// (I) ƥɥ
)
{
	gchar			*cal_str[] = {		// ʸ
						"", "", "", "", "ʿ"
					};
	GtkWidget		*birth_window;		// ϥɥ
	GtkWidget		*birth_vbox;		//
	GtkWidget		*title_label;		// ٥
	GtkWidget		*name_hbox;			//
	gchar			*user_name;			// ̾
	GtkWidget		*cal_hbox;			// Ǽܥå
	GtkWidget		*cal_btn = NULL;	// ܥ
	GSList			*cal_group = NULL;	// 񥰥롼ײ
	gint			loop_cnt;			// 롼ץ
	GtkWidget		*ymd_hbox;			// ǯǼܥå
	GtkWidget		*ymd_label;			// ǯ٥
	GtkWidget		*ymd_spin;			//
	time_t			ymd_time;			// ɽ
	struct tm		*ymd_stime;			// ɽ
	gfloat			ymd_value;			// ǯ
	GtkWidget		*birth_sep;			// ѥ졼
	GtkWidget		*cmd_hbox;			// ܥܥå
	GtkWidget		*cmd_ok;			// ɽܥ
	GtkWidget		*cmd_cancel;		// ߥܥ
	gchar			*title;				// ȥʸ

	// ɥ
	title = g_strconcat("", NULL);
	birth_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(birth_window), title);
	gtk_window_set_position(GTK_WINDOW(birth_window),
							GTK_WIN_POS_MOUSE);
	gtk_window_set_policy(GTK_WINDOW(birth_window), TRUE, TRUE, FALSE);
	g_free(title);

	// ٥
	birth_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(birth_vbox), 2);
	gtk_container_add(GTK_CONTAINER(birth_window), birth_vbox);

	title = g_strconcat("ϤƤ", NULL);
	title_label = gtk_label_new(title);
	gtk_misc_set_alignment(GTK_MISC(title_label), 0, 0);
	gtk_box_pack_start(GTK_BOX(birth_vbox), title_label, TRUE, TRUE, 0);
	g_free(title);

	// ѥ졼
	birth_sep = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(birth_vbox), birth_sep, FALSE, TRUE, 5);

	// ̾
	name_hbox = gtk_hbox_new(FALSE, 10);
	gtk_container_border_width(GTK_CONTAINER(birth_window), 10);
	gtk_box_pack_start(GTK_BOX(birth_vbox), name_hbox, FALSE, TRUE, 0);

	title = g_strconcat("̾", NULL);
	title_label = gtk_label_new(title);
	gtk_misc_set_alignment(GTK_MISC(title_label), 0, 0);
	gtk_box_pack_start(GTK_BOX(name_hbox), title_label, FALSE, TRUE, 0);
	g_free(title);

	Wbrb_name = gtk_entry_new_with_max_length(20);
	user_name = (gchar *)wbr_get_user_info(WBR_PRM_ID_USERNAME, 0);
	if (user_name != NULL) {
		gtk_entry_set_text(GTK_ENTRY(Wbrb_name),
				(gchar *)wbr_get_user_info(WBR_PRM_ID_USERNAME, 0));
	}
	gtk_box_pack_start(GTK_BOX(name_hbox), Wbrb_name, FALSE, TRUE, 0);

	// 
	cal_hbox = gtk_hbox_new(FALSE, 10);
	gtk_container_border_width(GTK_CONTAINER(birth_window), 10);
	gtk_box_pack_start(GTK_BOX(birth_vbox), cal_hbox, FALSE, TRUE, 0);

	for (loop_cnt = 0;
		loop_cnt < (sizeof(cal_str) / sizeof(cal_str[0])); loop_cnt++) {
		if (loop_cnt) {
			cal_group =
				gtk_radio_button_group(GTK_RADIO_BUTTON(cal_btn));
			cal_btn = gtk_radio_button_new_with_label(cal_group,
											cal_str[loop_cnt]);
		}
		else {
			cal_btn = gtk_radio_button_new_with_label(NULL,
											cal_str[loop_cnt]);
		}
		if (Wbrb_calendar == loop_cnt) {
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(cal_btn),
										TRUE);
		}
		gtk_box_pack_start(GTK_BOX(cal_hbox), cal_btn, TRUE, TRUE, 0);
		gtk_signal_connect(GTK_OBJECT(cal_btn), "clicked",
							GTK_SIGNAL_FUNC(wbrb_cb_calendar_clicked),
							(gpointer)loop_cnt);
	}

	// ǯϥꥢ
	ymd_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(birth_vbox), ymd_hbox, TRUE, TRUE, 5);

	ymd_time = (time_t)wbr_get_user_info(WBR_PRM_ID_BIRTHDAY, 0);
	ymd_stime = localtime(&ymd_time);
	ymd_value = (gfloat)ymd_stime->tm_year + 1900
					- Wbrb_cal_year[Wbrb_calendar];
	Wbrb_year = (GtkAdjustment *)gtk_adjustment_new(ymd_value, 0.0,
										2100.0, 1.0, 100.0, 0.0);
	ymd_spin = gtk_spin_button_new(Wbrb_year, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(ymd_spin), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(ymd_spin),
									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(ymd_spin, 55, 0);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_spin, FALSE, TRUE, 5);
	ymd_label = gtk_label_new("ǯ");
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	ymd_value = (gfloat)ymd_stime->tm_mon + 1;
	Wbrb_month = (GtkAdjustment *)gtk_adjustment_new(ymd_value, 1.0,
										12.0, 1.0, 5.0, 0.0);
	ymd_spin = gtk_spin_button_new(Wbrb_month, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(ymd_spin), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(ymd_spin),
									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(ymd_spin, 55, 0);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_spin, FALSE, TRUE, 5);
	ymd_label = gtk_label_new("");
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	ymd_value = (gfloat)ymd_stime->tm_mday;
	Wbrb_day = (GtkAdjustment *)gtk_adjustment_new(ymd_value, 1.0,
										31.0, 1.0, 5.0, 0.0);
	ymd_spin = gtk_spin_button_new(Wbrb_day, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(ymd_spin), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(ymd_spin),
									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(ymd_spin, 55, 0);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_spin, FALSE, TRUE, 5);
	ymd_label = gtk_label_new("");
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	// ѥ졼
	birth_sep = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(birth_vbox), birth_sep, FALSE, TRUE, 5);

	// ܥ
	cmd_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_end(GTK_BOX(birth_vbox), cmd_hbox, FALSE, TRUE, 0);

	cmd_cancel = gtk_button_new_with_label("ߡ");
	gtk_box_pack_end(GTK_BOX(cmd_hbox), cmd_cancel, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(cmd_cancel), "clicked",
						GTK_SIGNAL_FUNC(wbrb_cb_cancel_clicked),
						GTK_OBJECT(birth_window));
	GTK_WIDGET_SET_FLAGS(cmd_cancel, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(cmd_cancel);

	cmd_ok = gtk_button_new_with_label("ɽ");
	gtk_box_pack_end(GTK_BOX(cmd_hbox), cmd_ok, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(cmd_ok), "clicked",
						GTK_SIGNAL_FUNC(wbrb_cb_ok_clicked),
						GTK_OBJECT(birth_window));
	GTK_WIDGET_SET_FLAGS(cmd_ok, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(cmd_ok);

	if (parent != NULL) {
		gtk_window_set_modal(GTK_WINDOW(birth_window), TRUE);
		gtk_window_set_transient_for(GTK_WINDOW(birth_window),
									GTK_WINDOW(parent));
	}

	return birth_window;
}
