/*
 * Хꥺɽե
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: brthm.h,v 1.1 2000/05/29 00:07:37 tonton Exp $
 */

#ifndef __BRTHM_H__
#define		__BRTHM_H__

#include <gtk/gtk.h>
#include <time.h>

#define		WBR_TITLE		"Хꥺɽե"
#define		WBR_VERSION		"0.10"

#define		WBR_INTERVAL	5
#define		WBR_CYCLE_PHYS	23
#define		WBR_CYCLE_SENS	28
#define		WBR_CYCLE_INTEL	33

enum {
	WBR_TYPE_PHYS = 1,
	WBR_TYPE_SENS = 2,
	WBR_TYPE_INTEL = 4,
	WBR_TYPE_WARN = 8
};

enum {
	WBR_PRM_ID_USERNAME = 1,
	WBR_PRM_ID_BIRTHDAY,
	WBR_PRM_ID_DISPPERIOD,
	WBR_PRM_ID_BIRTHYEAR,
	WBR_PRM_ID_DISPTOTAL,
	WBR_PRM_ID_CALENDAR,

	WBR_PRM_ID_GRAPHPOINT,
	WBR_PRM_ID_GRAPHWIDTH,
	WBR_PRM_ID_GRAPHHEIGHT,
	WBR_PRM_ID_LINEWIDTH,
	WBR_PRM_ID_GRAPHDISP,
	WBR_PRM_ID_DAYLINE,
	WBR_PRM_ID_GRAPHFORE,
	WBR_PRM_ID_GRAPHBACK,
	WBR_PRM_ID_GRAPHPHYS,
	WBR_PRM_ID_GRAPHSENS,
	WBR_PRM_ID_GRAPHINTEL,

	WBR_PRM_ID_DISPDAY,
	WBR_PRM_ID_BIRTHNUM
};

// br_misc.c
extern void			wbr_trim(gchar *);

// br_window.c
extern void			wbr_dialog_close_clicked(GtkButton *, gpointer);
extern GtkWidget	*wbr_create_main_window(void);

// br_draw.c
extern void			wbr_init_psi_table(void);
extern void			wbr_draw_brthm(void);
extern GtkWidget	*wbr_create_draw_area(GtkWidget *);

// br_birth.c
extern void			wbr_cb_mview_spcbirth_clicked(GtkWidget *,
												gpointer, guint);

// br_idate.c
extern void			wbr_cb_mview_date_specify_clicked(GtkWidget *,
												gpointer, guint);

// br_about.c
extern void			wbr_cb_mhelp_about_clicked(GtkWidget *,
												gpointer, guint);

// br_param.c
extern void			*wbr_get_param(gint);
extern void			wbr_put_param(gint, void *);
extern gint			wbr_read_inifile(void);
extern gint			wbr_write_inifile(void);
extern void			wbr_init_user_info(void);
extern void			*wbr_get_user_info(gint, gint);
extern void			wbr_put_user_info(gchar *, time_t);

#endif /* __BRTHM_H__ */
